(function($) {
	"use strict";
    var ASVGLottiesAnimationHandler = function($scope, $) {
		var container = $scope.find('.asvg-lotties-animation-wrapper'),            
            data_id = container.data("id"),
            container_id = document.getElementById(data_id),
            data_path = container.data("path"),
            data_loop = container.data("loop"),
            data_anim_renderer = "svg",
            data_width = container.data("width"),
            data_height = container.data("height"),
            data_playspeed = container.data("playspeed"),
            data_play_action = container.data("play_action"),
            data_scrollbased = container.data("scrollbased"),
            data_section_duration = container.data("section_duration"),
            data_section_offset = container.data("section_offset"),
            data_start_time = container.data("start_time"),
            data_end_time = container.data("end_time");
			
		var lotties_animation = lottie.loadAnimation({
		  container: container_id,
		  loop: (data_loop),
		  autoplay: (data_play_action === 'autoplay') ? true : false,
		  path: data_path
		});
		
		if (data_playspeed) {
			lotties_animation.setSpeed(data_playspeed);
		}
		
		var start_time = 1;
		if(data_start_time !='' && data_start_time !=undefined){
			start_time = data_start_time;
		}
		var end_time = lotties_animation.totalFrames;
			
		
		if(data_play_action){
			if(data_play_action === 'default'){				
					lotties_animation.goToAndStop(0);							
			}
			
			if(data_play_action === 'autoplay'){				
					lotties_animation.goToAndPlay(0);																					   
			}
		
		$.fn.isOnScreen = function(){
			var win = $(window);
			var viewport = {
				top : win.scrollTop(),
			};
			viewport.bottom = viewport.top + win.height();

			var bounds = this.offset();
			bounds.bottom = bounds.top + this.outerHeight();

			return (!(viewport.bottom < bounds.top || viewport.top > bounds.bottom));

			};


/*Auto - Hover*/			

			if(data_play_action === 'hover_auto'){			
					lotties_animation.goToAndPlay(0);					
				jQuery(container_id).mouseenter(function() {
					start_time = 1;
					end_time = lotties_animation.totalFrames;
					
					lotties_animation.playSegments([start_time, end_time], !0)
				})}

/*Scroll - Hover*/			

			if(data_play_action === 'hover'){			

				var lastCall = false;
				
				if (lastCall) clearTimeout(lastCall);
				lastCall = setTimeout(() => {

			$(window).scroll(function(){
				if (jQuery(container_id).isOnScreen()) {		
					lotties_animation.goToAndPlay(start_time + end_time, 0, !0);
				}})
					
				jQuery(container_id).mouseenter(function() {
					start_time = 1;
					end_time = lotties_animation.totalFrames;
					
					lotties_animation.playSegments([start_time, end_time], !0)
				})
				},100);}

/*Auto - Click*/

			if(data_play_action === 'click_auto'){			
					lotties_animation.goToAndPlay(0);	
				jQuery(container_id).click(function() {
					start_time = 1;
					end_time = lotties_animation.totalFrames;

					lotties_animation.playSegments([start_time, end_time], !0)
				})}

/*Scroll - Click*/

			if(data_play_action === 'click'){			
				
				var lastCall = false;
				
				if (lastCall) clearTimeout(lastCall);
				lastCall = setTimeout(() => {
				
			$(window).scroll(function(){
				if (jQuery(container_id).isOnScreen()) {		
					lotties_animation.goToAndPlay(start_time + end_time, 0, !0);
				}})
				jQuery(container_id).click(function() {
					start_time = 1;
					end_time = lotties_animation.totalFrames;

					lotties_animation.playSegments([start_time, end_time], !0)
				})
			},100);}

			
			$(window).on("lotties_load_animation resize scroll", function() {
		
			if(data_play_action === 'parallax_effect'){
				
				var section_offset = container.offset().top;
					var section_duration = data_section_duration;
					var offset_top = data_section_offset;
					var all_duration = section_duration + section_offset - offset_top;
					
					var find_scroll_perc = 0;
					if( $(window).scrollTop() >= (section_offset - offset_top ) && $(window).scrollTop() <= all_duration && data_scrollbased == 'custom'){
						var scrollpercent = 100 * ($(window).scrollTop() - (section_offset - offset_top)) / (section_duration);
						var find_scroll_perc = Math.round(scrollpercent);
					}else if( $(window).scrollTop() >= (section_offset - offset_top ) && $(window).scrollTop() >= all_duration && data_scrollbased == 'custom'){
						var find_scroll_perc = Math.round(100);
					}else if(data_scrollbased == 'document'){
						var scrollpercent = 100 * $(window).scrollTop() / ($(document).height() - $(window).height());
						var find_scroll_perc = Math.round(scrollpercent);
					}
					
					var start_time = 0;
					var stop_time = lotties_animation.totalFrames;
					if(data_start_time!='' && data_start_time!=undefined){
						start_time = data_start_time;
					}
					if(data_end_time!='' && data_end_time!=undefined){
						stop_time = data_end_time;
					}
					lotties_animation.goToAndStop(start_time, true)
					var currframe = ((find_scroll_perc)/100 ) * (stop_time - start_time);
					if(currframe >= stop_time){
						lotties_animation.goToAndStop(stop_time, true);
					}else{
						lotties_animation.goToAndStop((currframe + start_time), true);
					}
			}
			}), 
			
/*Scroll*/	
				$(window).scroll(function(){
					var lastCall = false;
					if(data_play_action === 'viewport'){
					if (jQuery(container_id).isOnScreen()) {	
					  if (lastCall) clearTimeout(lastCall);
					  lastCall = setTimeout(() => {

						lotties_animation.goToAndPlay(start_time + end_time, 0, !0);
					},100);} 
					}});
			
			
			
			jQuery(window).trigger("lotties_load_animation");
		}

	};
	 $(window).on('elementor/frontend/init', function() {
        elementorFrontend.hooks.addAction('frontend/element_ready/asvg_lottie_free.default', ASVGLottiesAnimationHandler);		elementorFrontend.hooks.addAction('frontend/element_ready/asvg_upload_free.default', ASVGLottiesAnimationHandler);

    });
})(jQuery);

/*isonscreen js*/!function(a){"use strict";a.fn.isOnScreen=function(b){var c=this.outerHeight(),d=this.outerWidth();if(!d||!c)return!1;var e=a(window),f={top:e.scrollTop(),left:e.scrollLeft()};f.right=f.left+e.width(),f.bottom=f.top+e.height();var g=this.offset();g.right=g.left+d,g.bottom=g.top+c;var h={top:f.bottom-g.top,left:f.right-g.left,bottom:g.bottom-f.top,right:g.right-f.left};return"function"==typeof b?b.call(this,h):h.top>0&&h.left>0&&h.right>0&&h.bottom>0}}(jQuery);